﻿###############################################################################
function NewFOPTConsumer_DOpus(){
###############################################################################
	$fs=@(); #for storing the function/method script blocks
	$me= #for storing the objects properties
	###########################################################################
	@{
		__Version        = 0.1;
		FOPTracker       = $null;
		Prefix           = ""; #[TrackerName]

		DORTExePath      = "";
	}
	###########################################################################
	function constructor(){
		$this.DORTExePath = (Get-Item "HKLM:\SOFTWARE\Microsoft\Windows\CurrentVersion\App Paths\DOpus.exe").GetValue("Path");
		$this.DORTExePath+= "\dopusrt.exe";
	}
	###########################################################################
	$fs+=,@('_Init', { param( $FOPTracker )
	###########################################################################
		$this.FOPTracker = $FOPTracker;
		$this.Prefix     = $this.FOPTracker.LogPrefix+".DOpus  : ";
		&$this.DORTExePath /acmd FOPTracker NAME="$($tracker.Name)" PATH="$($tracker.Folder)" OPTYPE="INIT"
	});
	###########################################################################
	$fs+=,@('OpToJSON', { param( $op )
	###########################################################################
		$op.Remove("included");
		$op.Remove("excluded");
		$op.Remove("opAge");
		$op.Remove("opProcessed");
		$json = (ConvertTo-Json -inputobject $op -compress);
		return $json.Trim('"');
	});
	###########################################################################
	$fs+=,@('OnCreate', { param( $op )
		&$this.DORTExePath /acmd FOPTracker NAME="$($tracker.Name)" PATH="$($tracker.Folder)" OPTYPE="created" OPDATA=($this.OpToJSON($op))
		LogOut "$($this.Prefix)Created [$($op.filePath)]";
	});
	###########################################################################
	$fs+=,@('OnChange', { param( $op )
		&$this.DORTExePath /acmd FOPTracker NAME="$($tracker.Name)" PATH="$($tracker.Folder)" OPTYPE="changed" OPDATA=($this.OpToJSON($op))
		LogOut "$($this.Prefix)Changed [$($op.filePath)]";
	});
	###########################################################################
	$fs+=,@('OnRename', { param( $op )
		&$this.DORTExePath /acmd FOPTracker NAME="$($tracker.Name)" PATH="$($tracker.Folder)" OPTYPE="renamed" OPDATA=($this.OpToJSON($op))
		LogOut "$($this.Prefix)Renamed [$($op.filePathOld)] -> [$($op.filePath)]";
	});
	###########################################################################
	$fs+=,@('OnMove', { param( $opDelete, $opCreate, $opMerged )
		&$this.DORTExePath /acmd FOPTracker NAME="$($tracker.Name)" PATH="$($tracker.Folder)" OPTYPE="moved" OPDATA=($this.OpToJSON($opMerged))
		LogOut "$($this.Prefix)Moved   [$($opDelete.filePath)] -> [$($opCreate.filePath)]";
	});
	###########################################################################
	$fs+=,@('OnReplace', { param( $op)
		&$this.DORTExePath /acmd FOPTracker NAME="$($tracker.Name)" PATH="$($tracker.Folder)" OPTYPE="replaced" OPDATA=($this.OpToJSON($op))
		LogOut "$($this.Prefix)Replacd [$($op.filePath)]";
	});
	###########################################################################
	$fs+=,@('OnDelete', { param( $op )
		&$this.DORTExePath /acmd FOPTracker NAME="$($tracker.Name)" PATH="$($tracker.Folder)" OPTYPE="deleted" OPDATA=($this.OpToJSON($op))
		LogOut "$($this.Prefix)Deleted [$($op.filePath)]";
	});
	###########################################################################
	$me.__Type = (gv MyInvocation -Scope 0).Value.MyCommand.Name -replace "^NEW-?", "";
	if (!$me.ContainsKey("__Version")){ $me.__Version = 0;}
	$this=new-object -typename 'System.Management.Automation.PSObject' -property $me;
	foreach($function in $fs){
		$this | add-member -me scriptmethod -na $function[0] -va $function[1]; }
	###########################################################################
	constructor;
	return $this;
}